/*----------------------------------------------------------------------
  File     : Item.h
  Contents : itemset management
  Author   : Bart Goethals
  Update   : 4/4/2003 
----------------------------------------------------------------------*/
#ifndef _ITEM_H
#define _ITEM_H
#include <set>
using namespace std;

class Item
{
public:

	Item(int i) : id(i), support(0), children(0) {}
	Item(const Item &i) : id(i.id), support(i.support), children(i.children) {}
	~Item(){}

	int getId() const {return id;}

	int Increment(int inc = 1) const {return support+=inc;}

	set<Item> *makeChildren() const;
	int deleteChildren() const;

	/*NEW*/
	//int getSupport() const {return support;}
	unsigned long getSupport() const {return support;}
	void setSupport(unsigned long supp) const {support = supp;}
	/*END NEW*/
	set<Item> *getChildren() const {return children;}

	bool operator<(const Item &i) const{return id < i.id;}


private:

	const int id;
	/*NEW*/
	/*mutable int support;*/
	mutable unsigned long support;
	/*END NEW*/
	mutable set<Item> *children;
};

#endif
