#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include "rsa.h"
#include "ssl.h"
#include "secure.h"

#define MAX_NUM 10

int main(int argc, char **argv)
{
     char *ip_file = "certificate/ip.txt";
     char **ip_addresses;
     int hosts_num;
     unsigned long result;
     unsigned long i,j,k, total=0;
     unsigned long n;
     int prob;
     char **sets;
     time_t initial,final;
     unsigned long dim = ((n * n) * n) + 1;
     FILE *fp;
	
	
     if(argc < 4)
     {
	  printf("Devi inserire il nome del file e la dimensione dei sets e la probabilita'\n");
	  exit(1);
     }
     ip_addresses = ip_sort(ip_file, &hosts_num);
     srand(time(NULL));
     fp = fopen(argv[1], "w");
     n = atoi(argv[2]);
     prob = atoi(argv[3]);
     sets = malloc(dim * sizeof(char *));
     /*genero i sets*/
     for(i = 0; i < n; i++)
     {
	  for(j = 0; j < n; j ++)
	  {
	       for(k = 0; k < n; k ++)
	       {
		    if((rand() % prob) == 0)
		    {
			 char buff[20];
			 sprintf(buff,"%lu %lu %lu", i, j, k);
			 sets[total] = malloc(sizeof(strlen(buff)) + 1);
			 strcpy(sets[total], buff);
			 fprintf(fp, "%s\n", sets[total]);
			 total++;
		    } 
	       } 
	  }	
     }  
     sets[total] = NULL;		     
     initial = time(NULL);
     result = secure_intersection(ip_addresses, hosts_num, sets);
     final = time(NULL);	     
     printf("Set dimension = [%lu]; result  = [%lu]\n", total, result);
     printf("Total time : %.f s\n", difftime(final, initial));
     for(i = 0; i < total; i++)
     {
	  free(sets[i]);
     }
     free(sets);
     printf("\n");
     fclose(fp);

     return 0;
}
