#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include "rsa.h"
#include "ssl.h"
#include "secure.h"
#include "test_vector.h"

int main(int argc, char **argv)
{
     char *ip_file = "certificate/ip.txt";
     char **ip_addresses;
     int hosts_num;
     unsigned long scalar;
     unsigned i;
     unsigned long n = INITIAL_DIM;
     char *set;
     time_t initial,final;
     int n_test = 0;

     FILE *fp;
	
	
     if(argc < 2)
     {
	  printf("Devi inserire il nome del file\n");
	  exit(1);
     }
     ip_addresses = ip_sort(ip_file, &hosts_num);

   
     srand(time(NULL));
     
     fp = fopen(argv[1], "w");
     fclose(fp);

     while(n <= MAX_DIM)
     {
	  n_test++;
	  fp = fopen(argv[1], "a");
	  set = malloc((n + 1) * sizeof(char));
	  /*scrivo i valori sui file*/
	  for(i = 0; i < n; i++)
	  {
	       int h = rand() % 2;
	       if(!h)
	       {
		    set[i] = '0';
	       }
	       else
	       {
		    set[i] = '1';
	       }
	       fprintf(fp, "%c\n", set[i]);
	  }	  
	  set[n] = '\0';		     
	  initial = time(NULL);
	  scalar = secure_scalar_product(ip_addresses, hosts_num, set);
	  final = time(NULL);	     
	  printf("Test [%d]; n = [%lu]; result  = [%lu]\n", n_test, n, scalar);
	  printf("Total time : %.f s\n", difftime(final, initial));
	  fprintf(fp, "%lu\n", scalar);
	  free(set);
	  printf("\n");
	  fclose(fp);
	  n+=DELTA_DIM;
     }

     return 0;
}
